lots of updates, things working
[distro-setup] / mount-latest-subvol
1 #!/bin/bash
2 # Copyright (C) 2016 Ian Kelling
3 #
4 # Licensed under the Apache License, Version 2.0 (the "License");
5 # you may not use this file except in compliance with the License.
6 # You may obtain a copy of the License at
7 #
8 # http://www.apache.org/licenses/LICENSE-2.0
9 #
10 # Unless required by applicable law or agreed to in writing, software
11 # distributed under the License is distributed on an "AS IS" BASIS,
12 # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
13 # See the License for the specific language governing permissions and
14 # limitations under the License.
15
16 # usage: mount-latest-subvol
17
18 [[ $EUID == 0 ]] || exec sudo -E "$BASH_SOURCE" "$@"
19
20 errcatch() {
21 set -E; shopt -s extdebug
22 _err-trap() {
23 err=$?
24 exec >&2
25 set +x
26 echo "${BASH_SOURCE[1]}:${BASH_LINENO[0]}:in \`$BASH_COMMAND' returned $err"
27 bash-trace 2
28 echo "$0: exiting with code $err"
29 exit $err
30 }
31 trap _err-trap ERR
32 set -o pipefail
33 }
34 bash-trace() {
35 local -i argc_index=0 frame i start=${1:-1} max_indent=8 indent
36 local source
37 local extdebug=false
38 if [[ $(shopt -p extdebug) == *-s* ]]; then
39 extdebug=true
40 fi
41
42 for ((frame=0; frame < ${#FUNCNAME[@]}-1; frame++)); do
43 argc=${BASH_ARGC[frame]}
44 argc_index+=$argc
45 ((frame < start)) && continue
46 if (( ${#BASH_SOURCE[@]} > 1 )); then
47 source="${BASH_SOURCE[frame+1]}:${BASH_LINENO[frame]}:"
48 fi
49 indent=$((frame-start+1))
50 indent=$((indent < max_indent ? indent : max_indent))
51 printf "%${indent}s↳%sin \`%s" '' "$source" "${FUNCNAME[frame]}"
52 if $extdebug; then
53 for ((i=argc_index-1; i >= argc_index-argc; i--)); do
54 printf " %s" "${BASH_ARGV[i]}"
55 done
56 fi
57 echo \'
58 done
59 }
60 errcatch
61
62 tu() {
63 while read -r line; do
64 file="$1"
65 grep -xFq "$line" "$file" || tee -a "$file"<<<"$line"
66 done
67 }
68 e() { printf "%s\n" "$*"; "$@"; }
69 mnt() {
70 dir=$1
71 if ! mountpoint $dir &>/dev/null; then
72 mkdir -p $dir
73 e mount $dir
74 fi
75 }
76 fstab() {
77 while read -r start mpoint end; do
78 l="$start $mpoint $end"
79 # kill off any lines that duplicate the mount point.
80 sed --follow-symlinks -ri "\%$l%b;\%^\s*\S+\s+$mpoint\s%d" /etc/fstab
81 tu /etc/fstab <<<"$l"
82 done
83 }
84
85 ret=0
86
87 ##### begin setup fstab for subvols we care about ######
88 first_root_crypt=$(awk '$2 == "/" {print $1}' /etc/mtab)
89 fstab <<EOF
90 $first_root_crypt /a btrfs noatime,subvol=a 0 0
91 EOF
92 case $HOSTNAME in
93 treetowl|x2|frodo)
94 fstab <<EOF
95 $first_root_crypt /q btrfs noatime,subvol=q 0 0
96 $first_root_crypt /o btrfs noatime,subvol=o 0 0
97 /q/p /p none bind 0 0
98 /o/m /m none bind 0 0
99 EOF
100 ;;
101 esac
102 if [[ $HOSTNAME == frodo ]]; then
103 fstab <<EOF
104 $first_root_crypt /i btrfs noatime,subvol=i 0 0
105 EOF
106 fi
107 ##### end setup fstab for subvols we care about ######
108
109 for vol in q a o i; do
110 d=/$vol
111 if ! awk '{print $2}' /etc/fstab | grep -xF $d &>/dev/null; then
112 continue
113 fi
114
115
116 ##### begin building up list of bind mounts ######
117 binds=() # list of bind mounts
118 roots=($d) # list of bind mounts, plus the original mount
119 while true; do
120 new_roots=()
121 for r in ${roots[@]}; do
122 # eg. when r=/q/p, for lines like
123 # /q/p /p none bind 0 0
124 # output /p
125 new_roots+=($(sed -rn "s#^$r/\S+\s+(\S+)\s+none\s+bind\s.*#\1#p" /etc/fstab))
126 done
127 (( ${#new_roots} )) || break
128 binds+=(${new_roots[@]})
129 roots=( ${new_roots[@]} )
130 done
131 ##### end building up list of bind mounts ######
132
133
134 # if latest is already mounted, make sure binds are mounted and move on
135 if e check-subvol-stale $d; then
136 mnt $d
137 for b in ${binds[@]}; do
138 mnt $b
139 done
140 continue
141 fi
142
143 fresh_snap=$(</nocow/btrfs-stale/$vol)
144 if [[ ! $fresh_snap ]]; then
145 echo "$0: error. empty fresh_snap var"
146 ret=1
147 continue
148 fi
149
150 umount_ret=true
151 unmounted=()
152 for dir in $(echo $d ${binds[*]}\ |tac -s\ ); do
153 if mountpoint $dir; then
154 if e umount -R $dir; then
155 unmounted+=($dir)
156 else
157 echo "$0: failed to umount $dir"
158 # lsof will fail if it finds no pids
159 if ! e timeout 4 lsof $dir; then
160 umount_ret=false
161 ret=1
162 continue
163 fi
164 pids=$(lsof -t $dir) ||:
165 kill $pids
166 sleep .5
167 if e umount -R $dir; then
168 unmounted+=($dir)
169 else
170 umount_ret=false
171 ret=1
172 continue
173 fi
174 fi
175 fi
176 done
177
178 if ! $umount_ret; then
179 for dir in ${unmounted[@]}; do
180 mnt $dir
181 done
182 continue
183 fi
184
185 # todo: decipher /mnt/root, like we do in check-subvol-stale
186 cd /mnt/root
187 if [[ -e $vol ]]; then
188 e mv $vol $vol.leaf.$(date +%Y%m%dT%H%M%S%z)
189 fi
190 # Note, we make a few assumptions in this script, like
191 # $d was not a different subvol id than $vol, and
192 # things otherwise didn't get mounted very strangely.
193 e btrfs sub snapshot $fresh_snap $vol
194 for dir in $d ${binds[@]}; do
195 e mnt $dir
196 done
197 stale_dir=/nocow/btrfs-stale
198 rm -f $stale_dir/$d
199 done
200
201 ### disabled
202 if [[ $HOSTNAME == treetowlxxxxxxxxx ]]; then
203 # partitioned it with fai partitioner outside of fai,
204 # because it\'s worth it to have 1% space reserved for boot and
205 # swap partitions in case I ever want to boot off those drives.
206 # as root:
207 # . /a/bin/fai/fai-wrapper
208 # eval-fai-classfile /a/bin/fai/fai/config/class/51-multi-boot
209 # fai-setclass ROTATIONAL
210 # export LUKS_DIR=/q/root/luks/
211 # # because the partition nums existed already
212 # fai-setclass REPARTITION
213 # /a/bin/fai/fai/config/hooks/partition.DEFAULT
214
215 devs=(
216 ata-TOSHIBA_MD04ACA500_84REK6NTFS9A-part1
217 ata-TOSHIBA_MD04ACA500_84R2K773FS9A-part1
218 ata-TOSHIBA_MD04ACA500_8471K430FS9A-part1
219 ata-TOSHIBA_MD04ACA500_8481K493FS9A-part1
220 )
221 first=true
222 for dev in ${devs[@]}; do
223 if $first; then
224 first=false
225 tu /etc/fstab <<EOF
226 /dev/mapper/crypt_dev_$dev /i btrfs noatime,subvol=i,noauto 0 0
227 /dev/mapper/crypt_dev_$dev /mnt/iroot btrfs noatime,subvolid=0,noauto 0 0
228 EOF
229 fi
230 tu /etc/crypttab <<EOF
231 crypt_dev_$dev /dev/disk/by-id/$dev /q/root/luks/host-treetowl discard,luks
232 EOF
233 if [[ ! -e /dev/mapper/crypt_dev_$dev ]]; then
234 cryptdisks_start crypt_dev_$dev
235 fi
236 done
237 # note, could do an else here and have some kind of mount for /i
238 # on other hosts.
239 fi
240
241 exit $ret